<html>
<head>
<title>RIS Event Log Reader</title>
<style type="text/css">
body
{
   font-family:Arial,sans-serif;
   margin:0px;
   padding:0px;
   font-size:11px;
}

table,input,select
{
   font-family:Arial,sans-serif;
   font-size:11px;
}

h3.subTitle 
{
   background-color:#666;
   font-weight:bold;
   color:#fff;
   padding:2px 5px 2px 8px;
   margin:0px;
   font-size:100%;
   text-align:left;
}

div.subTitleBottomEdge 
{
   height:3px;
   overflow:hidden;
   background:#484848;
}	
	
/* links */
a:link, a:visited, a:active, a:hover 
{
   color: #003399;
   text-decoration:none;
}
a:hover {
   color: #003399;
   text-decoration:underline;
}

#DIV_VIEW_ID
{
   height:50px;
   background:#ccc;
}

.moreInfoLabel 
{
    background-color:#968F89;
    font-weight:bold;
    text-align:left;
    vertical-align:top;
    white-space: nowrap;
    padding:3px 5px 2px 5px;
    color:#fff;
}

.moreInfoValue 
{
	color:black;
	background-color: #EEEEEE; 
   white-space: nowrap;
	text-align:left; 
	padding: 2px 4px 2px;
}
.moreInfoValueWrap
{
	color:black;
	background-color: #EEEEEE; 
   width: auto;
	text-align:left; 
	padding: 2px 4px 2px;
}

/* alternate table row colors */
.moreInfoAltRow {
    background-color:#F5F5F5;
}

.clear
{
   clear:both;
}

.divPadding
{
   padding:10px 0 0 0;
}

.SSDViewLabel
{
}

.SSDView
{
   position:absolute;
   width:100%;
}

.SSDViewSettings, .SSDViewSettingsIE
{
   float:left;
   padding-top:5px;
   padding-left:8px;
}

.SSDViewSettingsIE
{
   padding-top:4px;
}

.SSDView select
{
   margin:0 5px;
}

/* Application Masthead */

#ApplicationHeader {
   color:#fff;
}
table.applicationMastheadSmall,table.applicationMastheadSmall td {
   background-color:#003366;
   color:#fff;
   vertical-align:top;
}
td.mastheadTitle {
   padding-top:8px;
}
td.mastheadTitle h1{
   padding:0px;
   margin:0px;
   padding:0 16px;
   color:#fff;
   white-space:nowrap;
   font-weight:normal;
   font-size:180%;
}
td.mastheadLinks {   
   padding:5px 16px;
   white-space:nowrap;
   border-left:7px solid #fff;
}
</style>

<script type="text/javascript">
   var g_isMoz = false;
   if (window.navigator != null && window.navigator.userAgent.indexOf("ecko") != -1)
   {
      g_isMoz = true;
   }
   // g_isViewer is the switch to control where the program is called from.
   // It is set in HandleOnLoad() when the page is loaded.
   // If g_isViewer == false, it is called from ADU. Images/icons will be displayed.
   // If g_isViewer == true, it is called from viewer to display json files. Images/icons will not be displayed.
   var g_isViewer;
   var g_sJSONData = "";
   var g_oRisEventLogReport = null;
   var SSD_GROUP_BY_CONTROLLER = 0;

   function ajaxRequest()
   {
      var activexmodes = ["Msxml2.XMLHTTP", "Microsoft.XMLHTTP"];  //activeX versions to check for in IE
      if (window.ActiveXObject)
      { //Test for support for ActiveXObject in IE first (as XMLHttpRequest in IE7 is broken)
         for (var i = 0; i < activexmodes.length; i++)
         {
            try
            {
               return new ActiveXObject(activexmodes[i]);
            }
            catch (e)
            {
               //suppress error
            }
         }
      }
      else if (window.XMLHttpRequest) // if Mozilla, Safari etc
      {
         var req = new XMLHttpRequest();
         req.overrideMimeType("application/json");
         return req;
      }
      else
      {
         return false;
      }
   }

   // Gets element by ID.
   function GE(eid)
   {
      return document.getElementById(eid);
   }

   function getAttribute(oSmart, sID)
   {
      if (typeof (oSmart) != "undefined")
      {
         for (var i = 0; i < oSmart.length; ++i)
         {
            if (typeof (oSmart[i].ID) != "undefined")
            {
               if (oSmart[i].ID == sID)
               {
                  return oSmart[i].Value;
               }
            }
         }
      }
   }

   // Ris Event Log Report Classes
   function CRisEventLogReport(sViewID, sLogID)
   {
      var m_sViewContainerID = sViewID;
      var m_sViewLogID = sLogID;
      var m_sViewID = sViewID + "_BUTTONS";
      this.m_oCtrlContainer = new CCtrlContainer();
      var m_oView = new CCtrlView(this, m_sViewID, this.m_oCtrlContainer);
      var m_isAlt = 0; // alternate the rows light/dark/light/dark, etc.
      var m_sAltClass = " moreInfoAltRow";

      this.draw = function()
      {
         var s = '';
         var oMPL = g_sJSONData.RISData.MetaPropertyList;

         // Draw banner only in viewer
         if (g_isViewer)
         {
            var sApp = getAttribute(oMPL, "Application Name");
            var sVersion = getAttribute(oMPL, "Version");
            s += '<div id="ApplicationHeader" style="height:40px;">';
            s += '<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%" class="applicationMastheadSmall">';
            s += '<tr>';
            s += '<td class="mastheadTitle" width="80%"><h1>HP ADU RIS Event Log Reader</h1></td>';
            s += '<td class="mastheadLinks" width="20%" lang="en">';
            s += '<br>Version: ' + sApp + ' ' + sVersion + '</td>';
            s += '</tr>';
            s += '</table>';
            s += '</div>';
            GE("banner").innerHTML = s;
            s = '';
         }

         // View Container.
         s += '<table width="100%" cellpadding="0" cellspacing="0"><tr><td>';
         s += '<div id="' + m_sViewContainerID + '">';
         s += '<table width="100%" cellpadding="0" cellspacing="0" bgcolor="#666666"><tr><td><h3 class="subTitle">Controller Event Logs</h3></td>';
         s += '<td align="right">Time Generated: ' + getAttribute(oMPL, "Time Generated") + '</td></tr></table>';
         s += '<div class="subTitleBottomEdge"></div>';
         s += '<div id="' + m_sViewID + '" class="SSDView"></div>';
         s += '</div></td></tr>';

         // Log
         s += '<tr><td><div id="' + m_sViewLogID + '">';
         s += '</div></td></tr></table>';

         GE("RisEventLogReport").innerHTML = s;
         m_oView.draw();
         this.DrawLogs(0);
      }

      this.updateControllerChange = function(sVal)
      {
         this.DrawLogs(sVal);
      }

      // Toggles the shade of the cell to be displayed next in a table and 
      // returns which shade to be used now.
      this.getAlt = function()
      {
         var sAltClass = m_isAlt ? m_sAltClass : "";
         m_isAlt = !m_isAlt;
         return sAltClass;
      }

      this.resetAlt = function()
      {
         m_isAlt = 0;
      }

      this.DisplayLogHeader = function()
      {
         var s = '<tr>';
         s += '<td class="moreInfoLabel">Event ID</td><td class="moreInfoLabel">Timestamp</td>' 
            + '<td class="moreInfoLabel">Class</td><td class="moreInfoLabel">Subclass</td>'
            + '<td class="moreInfoLabel">Summary</td><td class="moreInfoLabel">Detail</td>';
         s += '</tr>';
         return s;
      }

      // Displays log for a ctroller.
      this.DrawLogs = function(sVal)
      {
         this.resetAlt();
         var s = "";

         var nCtrl = Math.floor(parseInt(sVal) / 100);
         var nLog = parseInt(sVal) % 100;

         var aEventLogs = this.m_oCtrlContainer.getCtrollerLog(nCtrl);

         if (aEventLogs)
         {
            s += '<table width="100%"><tr><td class="moreInfoLabel" width="50px">Devices: </td><td class="moreInfoValueWrap moreInfoAltRow">' + aEventLogs[nLog].Devices + '</td>';
            s += '<td class="moreInfoLabel" align="right" width="110px">Number of Events: </td><td class="moreInfoValue moreInfoAltRow" align="right"  width="25px">' + aEventLogs[nLog].NumEvents + '</td></tr></table>';

            var aEvents = aEventLogs[nLog].Events;
            s += "<table>";
            s += this.DisplayLogHeader();
            for (var i = 0; i < aEvents.length; i++)
            {
               var sRowColor = this.getAlt();
               s += '<tr>' +
                  '<td class="moreInfoValue' + sRowColor + '">' + aEvents[i].ID +
                  '</td><td class="moreInfoValue' + sRowColor + '">' + aEvents[i].Timestamp +
                  '</td><td class="moreInfoValue' + sRowColor + '">' + aEvents[i].Class +
                  '</td><td class="moreInfoValue' + sRowColor + '">' + aEvents[i].Subclass +
                  '</td><td class="moreInfoValue' + sRowColor + '">' + aEvents[i].Summary +
                  '</td><td class="moreInfoValueWrap' + sRowColor + '">' + aEvents[i].Detail +
                  '</td></tr>';
            }
            s += "</table>";
         }
         else
         {
            s = "<br><h3>The selected controller does not contain a valid RIS event log. The controller has no physical drives attached, is not configured, or the RIS event log is not compatible with this utility.</h3>";
         }

         var o = GE(m_sViewLogID);
         o.innerHTML = s;
      }
   }

   function CCtrlContainer()
   {
      var m_oCtrls;

      this.Destructor = function()
      {
         if (m_oCtrls != null)
         {
            for (var i = 0; i < m_oCtrls.length; ++i)
            {
               m_oCtrls[i] = null;
            }
            m_oCtrls = null;
         }
      }

      this.getCtrls = function()
      {
         return m_oCtrls;
      }

      this.getCtrollerName = function(index)
      {
         return m_oCtrls[index].Name;
      }

      this.getCtrollerLog = function(index)
      {
         return m_oCtrls[index].EventLogs;
      }

      this.Constructor = function()
      {
         m_oCtrls = g_sJSONData.RISData.ControllerList;
      }

      this.Constructor();
   }

   // Contains controls for managing the view and layout of the device tree.
   function CCtrlView(oParent, sViewID, oCtrlContainer)
   {
      var m_sViewID = sViewID;
      var m_oCtrlContainer = oCtrlContainer;
      var m_sControllerSelectorID = "dropdownControllers";
      var m_oControllerDOMElement;
      this.m_oParent = oParent;
      var m_sControllerIndex = 0;
      var m_sViewSettingsClass = g_isMoz ? "SSDViewSettings" : "SSDViewSettingsIE";

      function getOption(sVal, sLabel, sCurrentVal)
      {
         var sHTML = "<option ";
         if (sVal == sCurrentVal)
         {
            sHTML += "selected ";
         }
         sHTML += "value='" + sVal + "'>";
         sHTML += sLabel + "</option>";
         return sHTML;
      }

      this.draw = function()
      {
         var aCtrls = oCtrlContainer.getCtrls();

         var sHTML = "<div class=\"" + m_sViewSettingsClass + "\">";
         sHTML += "<span class='SSDViewLabel'>Select a Controller</span>";
         sHTML += "<select id='" + m_sControllerSelectorID + "'>";

         for (var i = 0; i < aCtrls.length; i++)
         {
            var aEventLogs = m_oCtrlContainer.getCtrollerLog(i);

            if (aEventLogs)
            {
               // Loop through aEventLogs
               for (var j = 0; j < aEventLogs.length; j++)
               {
                  sHTML += getOption(i * 100 + j, m_oCtrlContainer.getCtrollerName(i) + " - Event Log " + (j + 1), m_sControllerIndex);
               }
            }
            else
            {
               sHTML += getOption(i * 100, m_oCtrlContainer.getCtrollerName(i), m_sControllerIndex);
            }
         }
         sHTML += "</select>";
         sHTML += "</div><div class=\"clear\"></div>";
         var o = GE(m_sViewID);
         if (o)
         {
            o.innerHTML = sHTML;
         }

         this.InitPost();
      }

      this.updateControllerChange = function(oParent)
      {
         var oOpt = GE(m_sControllerSelectorID);
         if (oOpt)
         {
            m_sControllerIndex = oOpt.value;
            oParent.updateControllerChange(m_sControllerIndex);
         }
      }

      this.InitPost = function()
      {
         m_oControllerDOMElement = GE(m_sControllerSelectorID);
         m_oControllerDOMElement.onchange = CCtrlView.onChangeController(this);
      }
   }

   CCtrlView.onChangeController = function(oCtrlView)
   {
      return (function(e)
      {
         oCtrlView.updateControllerChange(oCtrlView.m_oParent);
      });
   }

   function CRequestor()
   {
      var m_requestor = false; // XMLHttpRequest object
      var m_pfCallback = false; // possible callback function that the user specifies.
      var m_sFalseDataResponse = "FalseDataResponse";
      this.m_attrList = new Array(); // Name/value pairs
      var m_sRequestType = "";
      // Request Callback Support
      var m_cbInstance = 0;
      var m_cbFunc = 0;
      var m_dsw = 0;
      var m_evalResult = true;    // Run the return value through an "eval"

      this.setEvalResult = function(evalResult)
      {
         m_evalResult = evalResult;
      }

      this.setRequestType = function(sType)
      {
         m_sRequestType = sType;
      }

      this.Constructor = function()
      {
         if (document.location.protocol != "hpapp:" && window.XMLHttpRequest)
         {
            try { m_requestor = new XMLHttpRequest(); }
            catch (e)
            {
               alert("Error creating XMLHttpRequest object");
               m_requestor = false;
            }
         }
         else if (window.ActiveXObject)
         {
            try { m_requestor = new ActiveXObject("Microsoft.XMLHTTP"); }
            catch (e)
            {
               alert("Error creating Microsoft.XMLHTTP object");
               m_requestor = false;
            }
         }
      }
      this.Constructor();

      //    requestor.getDevice(<uniqueId>);
      //    requestor.getDevice(<uniqueId>, callBackFunc);
      //    requestor.getDevice(<uniqueId>, this/obj, "callBackFunc");
      this.executeRequest = function(cbInstance, cbFunc)
      {
         var device; // To be a Device object
         // currently set to synchronous mode, so when this next call
         // comes back, our data will be ready to go. 
         var isAsync = false;
         var sURL = m_sRequestType;
         var sParams = this.m_attrList.join("&");
         // Use POST for all requests.
         var sMethodType = "POST";

         if (cbInstance && cbFunc)
         {
            m_cbInstance = cbInstance;
            m_cbFunc = cbFunc;   // public function
            this.sendRequest(sURL, getResult, sMethodType, sParams);
         }
         else if (cbInstance)
         {
            m_cbFunc = cbInstance; // In this case cbInstance is really a private/global function
            this.sendRequest(sURL, getResult, sMethodType, sParams);
         }
         else
         {
            this.sendRequest(sURL, false, sMethodType, sParams);
            return getResult(this.getResponse(), false);
         }
      }

      function getResult(sReturnData, bReturnArray)
      {
         if (sReturnData.length > 5)
         {
            if (sReturnData.substr(0, 3) == "SIG")
            {
               // Examine status string
               g_lockState = sReturnData.substr(3, 2);
               sReturnData = sReturnData.substr(5);

               var continueProcessing = true;
               if (g_lockState != "OK")
               {
                  continueProcessing = InvokeErrorHandler(g_lockState, sReturnData);
               }
               if (continueProcessing)
               {
                  if (m_evalResult)
                  {
                     // Create variable 'd1'. If multiple devices are requested,
                     // they will be returned in the array variable 'ar'
                     eval(sReturnData);
                  }

                  if (m_evalResult)
                  {
                     if (m_cbInstance && m_cbFunc)
                     {
                        eval("m_cbInstance." + m_cbFunc + "(d1)");
                     }
                     else if (m_cbFunc)
                     {
                        m_cbFunc(d1);
                     }
                     // If setDevice() was used to request multiple devices,
                     // then return array 'ar' containing the returned devices.
                     else if (bReturnArray)
                     {
                        return ar;
                     }
                     else
                     {
                        return d1;
                     }
                  }
                  else
                  {
                     if (m_cbInstance && m_cbFunc)
                     {
                        eval("m_cbInstance." + m_cbFunc + "(sReturnData)");
                     }
                     else if (m_cbFunc)
                     {
                        m_cbFunc(sReturnData);
                     }
                     else
                     {
                        return sReturnData;
                     }
                  }
               }
            }
         }
      }

      this.setAttribute = function(name, value)
      {
         this.m_attrList[this.m_attrList.length] = name + "=" + value;
      }

      this.sendRequest = function(sURL, pfCallback, sMethodType, sParams)
      {
         if (m_requestor)
         {
            var x_date = new Date();
            x_startRequestTime = x_date.getTime();
            if (pfCallback)
            {
               m_pfCallback = pfCallback;
               m_requestor.onreadystatechange = getResponseHandler;
               m_requestor.open(sMethodType, sURL, true); // Asynchronous
            }
            else
            {
               m_requestor.open(sMethodType, sURL, false); // Synchronous
            }
            m_requestor.send(sParams);
         }
      }

      function getResponseData()
      {
         var sResponseText = m_sFalseDataResponse;
         if (m_requestor.readyState == 4)
         {
            if (m_requestor.status == 200 || m_requestor.status == 0)
            {
               sResponseText = m_requestor.responseText;
            }
            else
            {
               alert("The connection to the HTTP server has been lost. Check the network connection and server status, then refresh the browser.");
            }
         }
         return sResponseText;
      }

      function getResponseHandler()
      {
         var sResponseData = getResponseData();
         if ((sResponseData != m_sFalseDataResponse) && m_pfCallback)
         {
            m_pfCallback(sResponseData);
         }
      }

      this.getResponse = function()
      {
         return getResponseData();
      }
   }

   function printJaveObject(obj)
   {
      var out = '';
      for (var p in obj)
      {
         out += p + ': ' + obj[p] + '\n';
      }
      alert(out);
   }

   function printJaveObject2(obj)
   {
      var out = '';
      for (var p in obj)
      {
         out += p + ': ' + obj[p] + '||';
      }
      alert(out);
   }

   function HandleOnLoad()
   {
      // Check where this called from.
      if (typeof (parent.globalCallFromApp) != 'undefined' && parent.globalCallFromApp == true)
      {
         // If this page is called from ADU app, parent.globalCallFromApp is set to true in ADU.frm.
         g_isViewer = false;
      }
      else
      {
         // If this page is called from viewer, parent.globalCallFromApp is not set.
         g_isViewer = true;
      }

      // fake is to display image version in the viewer mode..
      var fake = false;
      if (g_isViewer || fake) // Viewer
      {
         if (fake == true)
         {
            g_isViewer = false;
         }

         var req = new ajaxRequest();
         req.onreadystatechange = function()
         {
            if (req.readyState == 4)
            {
               if (req.status == 200 || window.location.href.indexOf("http") == -1)
               {
                  g_sJSONData = eval("(" + req.responseText + ")"); // retrieve result as a JavaScript object
                  g_oRisEventLogReport = new CRisEventLogReport("DIV_VIEW_ID", "DIV_LOG_ID");
                  g_oRisEventLogReport.draw();
               }
               else
               {
                  alert("An error has occured making the request");
               }
            }
         }

         req.open("POST", "RISTemplate.json", true);
         req.send(null);
      }
      else // ADU 
      {
         parent.document.title = "HP Array Diagnostics and SmartSSD Wear Gauge Utility : View Ris Event Log Report";

         var reportRequestor = new CRequestor();
         reportRequestor.setRequestType("RISEventLogs.js");
         reportRequestor.setEvalResult(false);

         g_sJSONData = eval("(" + reportRequestor.executeRequest() + ")"); // retrieve result as a JavaScript object
         g_oRisEventLogReport = new CRisEventLogReport("DIV_VIEW_ID", "DIV_LOG_ID");
         g_oRisEventLogReport.draw();
         parent.footerArea.saveReportButton.onclick = function() { document.location = "ADUSSDReport.zip" };
         parent.footerArea.ShowSaveButton();
         parent.footerArea.ShowHomeButton();
         parent.footerArea.ShowCancelButton(false);
      }
   }

</script>
</head>
<body onload="HandleOnLoad();">
<div id="banner"></div>
<div id="RisEventLogReport"></div>
</body>
</html>