#!/bin/sh
# The purpose of this script is to prepare the SMH environment to run ADU
# Pre-condition: 
#   SMH must be installed and running
# Post-conditions: 
#   The SMH webapps directory will have a link to the ADU.xml file
#   The SMH data/htdocs directory will have a link to the ADU HTML files
#   The files in the ADU/bld directory will have appropriate permissions to be run from SMH
HPSMH_DIR=/opt/hp/hpsmh
INSTALL_ROOT=/opt/hp/hpadu/

#
# see if hpsmh is installed and running
HPSMH_INSTALL=`rpm -q hpsmh`
if [ $? == 0 ] && [ -f "/opt/hp/hpsmh/logs/httpd.pid" ]
then
	# XML file to SMH/webapps
	mkdir -p $HPSMH_DIR/webapp
	rm -f $HPSMH_DIR/webapp/ADU.xml.inactive
	ln -sf ${INSTALL_ROOT}bld/ADU.xml $HPSMH_DIR/webapp/ADU.xml.inactive
	# HTML folder to SMH/data/htdocs/ADU
	rm -f $HPSMH_DIR/data/htdocs/ADU
	mkdir -p $HPSMH_DIR/data/htdocs
	ln -sf ${INSTALL_ROOT}HTML $HPSMH_DIR/data/htdocs/ADU
	chown hpsmh:hpsmh $HPSMH_DIR/data/htdocs/ADU
	# ipcelmclient executable
	chown root:hpsmh ${INSTALL_ROOT}bld/ipcelmclient
	chmod 6710 ${INSTALL_ROOT}bld/ipcelmclient
	ln -sf ${INSTALL_ROOT}bld/ipcelmclient $HPSMH_DIR/data/htdocs/ADU/ipcelmclient
	# ipcelmclient.php
	chmod 644 ${INSTALL_ROOT}bld/ipcelmclient.php
fi
